<?php
namespace LMS\Tools\Coursebuilder\Tables;

use LMS\Libraries\Base;

defined('_JEXEC') or die;


use Joomla\Registry\Registry;

class Modules extends Base\Table
{
	protected $fieldMap = array(
		'id' => 'id',
		'asset_id' => 'asset_id',
		'title' => 'title',
		'note' => 'note',
		'content' => 'content',
		'ordering' => 'ordering',
		'position' => 'position',
		'checked_out' => 'checked_out',
		'checked_out_time' => 'checked_out_time',
		'publish_up' => 'publish_up',
		'publish_down' => 'publish_down',
		'published' => 'published',
		'module' => 'module',
		'access' => 'access',
		'showtitle' => 'showtitle',
		'params' => 'params',
		'client_id' => 'client_id',
		'language' => 'language',
	);

	protected $alias = 'jmods';

	public function __construct($db=false)
	{
		parent::__construct('#__modules', 'id', $db);
	}
	
	public function bind($array, $ignore = '')
	{
		if (isset($array['params']) && is_array($array['params']))
		{
			$registry = new Registry;
			$registry->loadArray($array['params']);
			$array['params'] = (string) $registry;
		}

		return parent::bind($array, $ignore);
	}
}