<?php
namespace LMS\Tools\Coursebuilder\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class LearningPattern extends Base\View
{
	protected $extension = 'com_joomla_lms';
	protected $viewName = 'LearningPattern';

	protected $state;
	protected $pattern;
	protected $patternId;
	protected $tools;
	protected $toolbar;


	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

	public function show()
	{
		$modelLearningPattern = $this->getModel('LearningPattern');

		$this->state = $modelLearningPattern->getState();

		$this->pattern = new \stdClass();
		$this->pattern->savedPatternId = $modelLearningPattern->getSavedPatternId();
		$this->pattern->currentPatternId = $modelLearningPattern->getCurrentPatternId();
		$this->pattern->dataForSelectlist = $modelLearningPattern->getPatternSelectlist();
		$pattern = $modelLearningPattern->getCurrentPattern();
		$this->pattern->description = \JText::_($pattern->description);

		$this->tools = new \stdClass();
		$this->tools->teacher = $modelLearningPattern->getTools($userRole=1);
		$this->tools->learner = $modelLearningPattern->getTools($userRole=2);

		$this->modules = $modelLearningPattern->getModules();

		$this->addStyleSheet('/tools/coursebuilder/assets/css/style.css');

		$this->display();
	}
}